local MarketAddition= ...

MarketAddition:override({
    Id = "MONUMENT_MARKET",
    BuildingPartSetList = {
                Action = "APPEND",
		{
			Name = "MARKET_ADDITION_PARTSETLIST_NAME",
                	BuildingPartList = {
                            "MARKET_ADDITION_HAT_STALL_PART",
                            "MARKET_ADDITION_HAT_WORKSHOP_PART",
                            "MARKET_ADDITION_KNIFE_GRINDER_PART",
                            "MARKET_ADDITION_ROOF_CENTER_PART",
                            "MARKET_ADDITION_ROOF_CORNER_PART",
                            "MARKET_ADDITION_ROOF_ENTRANCE_PART",
                            "MARKET_ADDITION_HAT_SIGN_PART",
                            "MARKET_ADDITION_KNIFE_GRINDER_SIGN_PART"
                        }
                }
    }
})

MarketAddition:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "MARKET_ADDITION_HATMAKER_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 50,
		WorkerCapacity = 1,                
                RelatedJob = { Job = "HATMAKER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "WOOLEN_CLOTH", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "WOOLEN_CLOTH", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "HAT", Quantity = 1 }
                }
})

MarketAddition:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "MARKET_ADDITION_KNIFEGRINDER_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 50,
		WorkerCapacity = 1,
                RelatedJob = { Job = "KNIFEGRINDER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "TOOL", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "TOOL", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "KNIFE", Quantity = 1 }
                }
})

function registerMarketPart( _namePrefab, _nameAsset, _nameFunction)
-- Register prefab nodes (currently only one core model)
MarketAddition:registerAssetId("models/" .. _namePrefab .. "Part", "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB")

-- Register the building part
MarketAddition:register({
	DataType = "BUILDING_PART",
	Id = "MARKET_ADDITION_" .. _nameAsset .. "_PART",
	Name = "MARKET_ADDITION_" .. _nameAsset .. "_NAME",
	Description = "MARKET_ADDITION_" .. _nameAsset .. "_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	},
	AssetBuildingFunction = _nameFunction
})

-- Register grounding components
MarketAddition:registerPrefabComponent("models/" .. _namePrefab .. "Part", {
	DataType = "COMP_GROUNDED"
})

-- Override building part components properties (generated by the building asset processor) to add building zones
MarketAddition:registerPrefabComponent("models/" .. _namePrefab .. "Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})
end

registerMarketPart( "hatmaker.fbx/Prefab/marketAddition/hatStall", "HAT_STALL", "BUILDING_FUNCTION_GOODS_MARKET")
registerMarketPart( "hatmaker.fbx/Prefab/marketAddition/hatWorkshop", "HAT_WORKSHOP", "MARKET_ADDITION_HATMAKER_FUNCTION")
registerMarketPart( "knifegrinder.fbx/Prefab/marketAddition/knifeGrinder", "KNIFE_GRINDER", "MARKET_ADDITION_KNIFEGRINDER_FUNCTION")

function registerRoofPart( _namePrefab, _nameAsset)
-- Register prefab nodes (currently only one core model)
MarketAddition:registerAssetId("models/" .. _namePrefab .. "Part", "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB")

-- Register the hatmaker workplace part
MarketAddition:register({
	DataType = "BUILDING_PART",
	Id = "MARKET_ADDITION_" .. _nameAsset .. "_PART",
	Name = "MARKET_ADDITION_" .. _nameAsset .. "_NAME",
	Description = "MARKET_ADDITION_" .. _nameAsset .. "_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	}
})

-- Override building part components properties (generated by the building asset processor) to add building zones
MarketAddition:registerPrefabComponent("models/" .. _namePrefab .. "Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})
end

registerRoofPart( "hatmaker.fbx/Prefab/marketAddition/roofCenter", "ROOF_CENTER")
registerRoofPart( "hatmaker.fbx/Prefab/marketAddition/roofCorner", "ROOF_CORNER")

function registerEntrancePart( _namePrefab, _nameAsset)
-- Register prefab nodes (currently only one core model)
MarketAddition:registerAssetId("models/" .. _namePrefab .. "Part", "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB")

-- Register the hatmaker workplace part
MarketAddition:register({
	DataType = "BUILDING_PART",
	Id = "MARKET_ADDITION_" .. _nameAsset .. "_PART",
	Name = "MARKET_ADDITION_" .. _nameAsset .. "_NAME",
	Description = "MARKET_ADDITION_" .. _nameAsset .. "_DESC",
	Category = "Extension",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "MARKET_ADDITION_" .. _nameAsset .. "_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 }
		}
	}
})

-- Override building part components properties (generated by the building asset processor) to add building zones
MarketAddition:registerPrefabComponent("models/" .. _namePrefab .. "Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = false,
	BuildingZone = { 0, 0 }
})
end

registerEntrancePart( "hatmaker.fbx/Prefab/marketAddition/roofEntrance", "ROOF_ENTRANCE")
registerEntrancePart( "hatmaker.fbx/Prefab/marketAddition/hatSign", "HAT_SIGN", NIL)
registerEntrancePart( "knifegrinder.fbx/Prefab/marketAddition/knifeGrinderSign", "KNIFE_GRINDER_SIGN", NIL)


